commit eff452df296a6f3d0f94408bb2a4a5c4a3c86eb7
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Thu Jan 13 21:50:45 2022

    Fortran: fix ICE overloading elemental intrinsics
    
    gcc/fortran/ChangeLog:
    
            PR fortran/103782
            * expr.c (gfc_simplify_expr): Adjust logic for when to scalarize a
            call of an intrinsic which may have been overloaded.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/103782
            * gfortran.dg/overload_4.f90: New test.
    
    (cherry picked from commit a4a8ae123cd70188e4b4bf5e288a84e0a76fb0fd)

diff --git a/gcc/fortran/expr.c b/gcc/fortran/expr.c
index e1373490d0b..b3be37fb476 100644
--- a/gcc/fortran/expr.c
+++ b/gcc/fortran/expr.c
@@ -2216,10 +2216,9 @@ gfc_simplify_expr (gfc_expr *p, int type)
 	  && gfc_intrinsic_func_interface (p, 1) == MATCH_ERROR)
 	return false;
 
-      if (p->expr_type == EXPR_FUNCTION)
+      if (p->symtree && (p->value.function.isym || p->ts.type == BT_UNKNOWN))
 	{
-	  if (p->symtree)
-	    isym = gfc_find_function (p->symtree->n.sym->name);
+	  isym = gfc_find_function (p->symtree->n.sym->name);
 	  if (isym && isym->elemental)
 	    scalarize_intrinsic_call (p, false);
 	}
diff --git a/gcc/testsuite/gfortran.dg/overload_4.f90 b/gcc/testsuite/gfortran.dg/overload_4.f90
new file mode 100644
index 00000000000..43207e358ba
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/overload_4.f90
@@ -0,0 +1,27 @@
+! { dg-do run }
+! { dg-additional-options "-Wno-intrinsic-shadow" }
+! PR fortran/103782 - ICE overloading an intrinsic like dble or real
+! Contributed by Urban Jost
+
+program runtest
+  implicit none
+  interface dble
+     procedure to_double
+  end interface dble
+  interface real
+     procedure floor ! not really FLOOR...
+  end interface real
+  if (any (dble ([10.0d0,20.0d0]) - [10.0d0,20.0d0] /= 0.d0)) stop 1
+  if (any (real ([1.5,2.5])       - [1.5,2.5]       /= 0.0 )) stop 2
+contains
+  elemental function to_double (valuein) result(d_out)
+    doubleprecision,intent(in) :: valuein
+    doubleprecision            :: d_out
+    d_out=valuein
+  end function to_double
+  elemental function floor (valuein) result(d_out) ! not really FLOOR...
+    real, intent(in) :: valuein
+    real             :: d_out
+    d_out=valuein
+  end function floor
+end program runtest

